Package net.commoble.exmachina.api

# Record Class StateWirer

java.lang.Object
java.lang.Record
net.commoble.exmachina.api.StateWirer

Record Components:
  `state` - BlockState associated with the signal components
  `source` - SignalSource of the blockstate
  `transmitter` - SignalTransmitter of the blockstate
  `receiver` - SignalReceiver of the blockstate

public record StateWirer(net.minecraft.world.level.block.state.BlockState state, SignalSource source, SignalTransmitter transmitter, SignalReceiver receiver) extends Record
Signal Source+Transmitter+Receiver bound together from a given position

## Constructor Summary

Constructors
Constructor
Description
`StateWirer(net.minecraft.world.level.block.state.BlockState state, SignalSource source, SignalTransmitter transmitter, SignalReceiver receiver)`
Creates an instance of a `StateWirer` record class.

## Method Summary

Modifier and Type
Method
Description
`final boolean`
`equals(Object o)`
Indicates whether some other object is "equal to" this one.
`static StateWirer`
`getOrDefault(net.minecraft.world.level.BlockGetter blockGetter, net.minecraft.core.BlockPos pos)`
Returns StateWirer using default wiring components if the given block has none assigned.
`final int`
`hashCode()`
Returns a hash code value for this object.
`boolean`
`ignoreVanillaSignal(net.minecraft.world.level.LevelReader levelReader)`
Returns true if a signal graph should ignore vanilla redstone signal emitted by this block.
`SignalReceiver`
`receiver()`
Returns the value of the `receiver` record component.
`SignalSource`
`source()`
Returns the value of the `source` record component.
`net.minecraft.world.level.block.state.BlockState`
`state()`
Returns the value of the `state` record component.
`final String`
`toString()`
Returns a string representation of this record class.
`SignalTransmitter`
`transmitter()`
Returns the value of the `transmitter` record component.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### StateWirer

public StateWirer(net.minecraft.world.level.block.state.BlockState state, SignalSource source, SignalTransmitter transmitter, SignalReceiver receiver)
Creates an instance of a `StateWirer` record class.

Parameters:
  `state` - the value for the `state` record component
  `source` - the value for the `source` record component
  `transmitter` - the value for the `transmitter` record component
  `receiver` - the value for the `receiver` record component

## Method Details

### getOrDefault

public static StateWirer getOrDefault(net.minecraft.world.level.BlockGetter blockGetter, net.minecraft.core.BlockPos pos)
Returns StateWirer using default wiring components if the given block has none assigned.

Parameters:
  `blockGetter` - BlockGetter where a signal graph is
  `pos` - BlockPos to get the wiring components from
Returns:
  StateWirer using default wiring components if the given block has none assigned

### ignoreVanillaSignal

public boolean ignoreVanillaSignal(net.minecraft.world.level.LevelReader levelReader)
Returns true if a signal graph should ignore vanilla redstone signal emitted by this block.

Parameters:
  `levelReader` - LevelReader to read signal from
Returns:
  true if a signal graph should ignore vanilla redstone signal emitted by this block

### toString

public final String toString()
Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.

Specified by:
  `toString` in class `Record`
Returns:
  a string representation of this object

### hashCode

public final int hashCode()
Returns a hash code value for this object. The value is derived from the hash code of each of the record components.

Specified by:
  `hashCode` in class `Record`
Returns:
  a hash code value for this object

### equals

public final boolean equals(Object o)
Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.

Specified by:
  `equals` in class `Record`
Parameters:
  `o` - the object with which to compare
Returns:
  `true` if this object is the same as the `o` argument; `false` otherwise.

### state

public net.minecraft.world.level.block.state.BlockState state()
Returns the value of the `state` record component.

Returns:
  the value of the `state` record component

### source

public SignalSource source()
Returns the value of the `source` record component.

Returns:
  the value of the `source` record component

### transmitter

public SignalTransmitter transmitter()
Returns the value of the `transmitter` record component.

Returns:
  the value of the `transmitter` record component

### receiver

public SignalReceiver receiver()
Returns the value of the `receiver` record component.

Returns:
  the value of the `receiver` record component